using Tiger.Communication.Messages.Interfaces;
using Tiger.Communication.Messages.Outgoing.Handshake;
using Tiger.Communication.Messages.Types;
using Tiger.Networking.Game.Sessions;

namespace Tiger.Communication.Messages.Incoming.Handshake;

public class GetSessionParametersEvent : IMessageEvent
{
    public IncomingHeaders Header => IncomingHeaders.GetSessionParameters;

    public async Task HandleAsync(GameSession gameSession, ClientMessage request)
    {
        await gameSession.SendComposerAsync(new SessionParametersComposer(0, true,
            false, false, true, "d-M-Y"));
    }
}