using Tiger.Communication.Messages.Interfaces;
using Tiger.Communication.Messages.Outgoing.Users;
using Tiger.Communication.Messages.Types;
using Tiger.Networking.Game.Sessions;

namespace Tiger.Communication.Messages.Incoming.Users;

public class GetInfoEvent : IMessageEvent
{
    public IncomingHeaders Header => IncomingHeaders.GetInfo;
    public async Task HandleAsync(GameSession gameSession, ClientMessage request)
    {
        if (gameSession.Habbo == null)
        {
            await gameSession.CloseAsync();
            return;
        }

        await gameSession.SendComposerAsync(new UserObjComposer(gameSession.Habbo));
    }
}