using Tiger.Communication.Messages.Interfaces;
using Tiger.Communication.Messages.Types;

namespace Tiger.Communication.Messages.Outgoing.Handshake;

public class SecretKeyComposer : IMessageComposer
{
    private readonly string _publicKey;

    public SecretKeyComposer(string publicKey)
    {
        _publicKey = publicKey;
    }

    public OutgoingHeaders Header => OutgoingHeaders.SecretKey;
    public void Compose(ServerMessage message)
    {
        message.AppendString(_publicKey);
    }
}