using Tiger.Communication.Messages.Interfaces;
using Tiger.Communication.Messages.Types;

namespace Tiger.Communication.Messages.Outgoing.Navigator;

public class FlatCreatedComposer : IMessageComposer
{
    private readonly int _roomId;
    private readonly string _name;

    public FlatCreatedComposer(int roomId, string name)
    {
        _roomId = roomId;
        _name = name;
    }

    public OutgoingHeaders Header => OutgoingHeaders.FlatCreated;
    public void Compose(ServerMessage message)
    {
        message.AppendWire(_roomId);
        message.AppendString(_name);
    }
}