using Tiger.Communication.Messages.Interfaces;
using Tiger.Communication.Messages.Types;
using Tiger.Game.Habbos;

namespace Tiger.Communication.Messages.Outgoing.Users;

public class UserObjComposer : IMessageComposer
{
    private readonly Habbo _habbo;

    public UserObjComposer(Habbo habbo)
    {
        _habbo = habbo;
    }

    public OutgoingHeaders Header => OutgoingHeaders.UserObj;
    public void Compose(ServerMessage message)
    {
        message.AppendString(_habbo.Username);
        message.AppendString(_habbo.Figure);
        message.AppendString(_habbo.Gender);
        message.AppendString(_habbo.Motto);
        message.AppendWire(0); // ph_tickets
        message.AppendString(string.Empty); // ph_figure
        message.AppendWire(0); // photo_film
        message.AppendWire(0); // direct_mail
    }
}