using System.Text;
using HabboEncoding;

namespace Tiger.Communication.Messages.Types;

public class ServerMessage
{
    private readonly List<byte> _packet = new();

    public ServerMessage(short header)
    {
        AppendB64(header);
    }

    public void AppendB64(int value)
    {
        _packet.AddRange(Base64Encoding.EncodeInt32(value));
    }

    public void AppendWire(int value)
    {
        _packet.AddRange(VL64Encoding.EncodeInt32(value));
    }
    
    public void AppendWire(bool value)
    {
        _packet.AddRange(VL64Encoding.EncodeInt32(value ? 1 : 0));
    }

    public void AppendString(string value, byte delim = 2)
    {
        _packet.AddRange(Encoding.UTF8.GetBytes(value));
        _packet.Add(delim);
    }

    public byte[] ToArray()
    {
        var finalizedPacket = new List<byte>();
        finalizedPacket.AddRange(_packet);
        finalizedPacket.Add(1);
        return finalizedPacket.ToArray();
    }
}