using FluentNHibernate.Mapping;

namespace Tiger.Game.Rooms.Models;

public class RoomModelMap : ClassMap<RoomModel>
{
    public RoomModelMap()
    {
        Table("room_models");
        LazyLoad();
        Id(rm => rm.Id).Column("id").GeneratedBy.Identity();
        Map(rm => rm.Name).Column("name").Not.Nullable();
        Map(rm => rm.DoorX).Column("door_x").Not.Nullable();
        Map(rm => rm.DoorY).Column("door_y").Not.Nullable();
        Map(rm => rm.DoorRotation).Column("door_rotation").Not.Nullable();
        Map(rm => rm.Heightmap).Column("heightmap").Not.Nullable();
        Map(rm => rm.ClubOnly).Column("club_only").Not.Nullable();
    }
}