using Tiger.Communication.Messages.Types;
using Tiger.Game.Habbos;
using Tiger.Game.Navigator.Nodes;
using Tiger.Game.Rooms.Models;

namespace Tiger.Game.Rooms;

public class Room
{
    public virtual int Id { get; set; }
    public virtual Habbo? Owner { get; set; }
    public virtual NavigatorNode Category { get; set; } = null!;
    public virtual string Name { get; set; } = null!;
    public virtual string Description { get; set; } = null!;
    public virtual int ModelId { get; set; }
    public virtual RoomModel Model { get; set; } = null!;
    public virtual string Ccts { get; } = null!;
    public virtual int Wallpaper { get; set; }
    public virtual int Floor { get; set; }
    public virtual bool ShowOwner { get; set; }
    public virtual bool Superusers { get; set; }
    public virtual RoomAccessType AccessType { get; set; }
    public virtual string Password { get; set; } = null!;
    public virtual int UsersIn { get; set; }
    public virtual int UsersMax { get; set; }

    public virtual void ParseNode(ServerMessage message)
    {
        message.AppendWire(Id);
        message.AppendString(Name);
        message.AppendString(ShowOwner ? Owner?.Username ?? "-" : "-");
        message.AppendString(AccessType.ToString().ToLower());
        message.AppendWire(UsersIn);
        message.AppendWire(UsersMax);
        message.AppendString(Description);
    }
}